#include <bits/stdc++.h>

using namespace std;

#define pb push_back

using vi = vector<int>;

const int maxN = 3e5;

struct Item {
    int dp, state;
};

struct Node {
    int ch[2], p;
    bool rev;
    int cnt, sum;
    Item dp, dprev;
} t[maxN];

int chnum(int i) {
    return t[t[i].p].ch[1] == i;
}

bool is_root(int i) {
    return t[i].p == -1 || t[t[i].p].ch[chnum(i)] != i;
}

void push(int i) {
    if (i == -1 || !t[i].rev) {
        return;
    }
    swap(t[i].ch[0], t[i].ch[1]);
    swap(t[i].dp, t[i].dprev);
    if (t[i].ch[0] != -1) {
        t[t[i].ch[0]].rev ^= 1;
    }
    if (t[i].ch[1] != -1) {
        t[t[i].ch[1]].rev ^= 1;
    }
    t[i].rev = false;
}

Item unite(Item l, Item r) {
    Item res;
    if (l.state == 0) {
        if (r.state == 0) {
            res.dp = l.dp + r.dp;
            res.state = 1;
        } else if (r.state == 1) {
            res.dp = l.dp + r.dp + 1;
            res.state = 0;
        } else if (r.state == 2) {
            res.dp = l.dp + r.dp;
            res.state = 3;
        } else if (r.state == 3) {
            res.dp = l.dp + r.dp + 1;
            res.state = 2;
        } else if (r.state == 4) {
            res.dp = l.dp + r.dp;
            res.state = 5;
        } else {
            res.dp = l.dp + r.dp + 1;
            res.state = 4;
        }
    } else if (l.state == 1) {
        if (r.state == 0) {
            res.dp = l.dp + 1 + r.dp;
            res.state = 0;
        } else if (r.state == 1) {
            res.dp = l.dp + r.dp + 1;
            res.state = 1;
        } else if (r.state == 2) {
            res.dp = l.dp + 1 + r.dp;
            res.state = 2;
        } else if (r.state == 3) {
            res.dp = l.dp + r.dp + 1;
            res.state = 3;
        } else if (r.state == 4) {
            res.dp = l.dp + 1 + r.dp;
            res.state = 4;
        } else {
            res.dp = l.dp + r.dp + 1;
            res.state = 5;
        }
    } else if (l.state == 2) {
        if (r.state == 0) {
            res.dp = l.dp + r.dp;
            res.state = 4;
        } else if (r.state == 1) {
            res.dp = l.dp + r.dp + 1;
            res.state = 2;
        } else if (r.state == 2) {
            res.dp = l.dp + r.dp;
            res.state = 2;
        } else if (r.state == 3) {
            res.dp = l.dp + r.dp + 1;
            res.state = 2;
        } else if (r.state == 4) {
            res.dp = l.dp + r.dp;
            res.state = 4;
        } else {
            res.dp = l.dp + r.dp + 1;
            res.state = 4;
        }
    } else if (l.state == 3) {
        if (r.state == 0) {
            res.dp = l.dp + r.dp;
            res.state = 5;
        } else if (r.state == 1) {
            res.dp = l.dp + r.dp + 1;
            res.state = 3;
        } else if (r.state == 2) {
            res.dp = l.dp + r.dp;
            res.state = 3;
        } else if (r.state == 3) {
            res.dp = l.dp + r.dp + 1;
            res.state = 3;
        } else if (r.state == 4) {
            res.dp = l.dp + r.dp;
            res.state = 5;
        } else {
            res.dp = l.dp + r.dp + 1;
            res.state = 5;
        }
    } else if (l.state == 4) {
        if (r.state == 0) {
            res.dp = l.dp + 1 + r.dp;
            res.state = 2;
        } else if (r.state == 1) {
            res.dp = l.dp + r.dp + 1;
            res.state = 4;
        } else if (r.state == 2) {
            res.dp = l.dp + 1 + r.dp;
            res.state = 2;
        } else if (r.state == 3) {
            res.dp = l.dp + r.dp + 1;
            res.state = 2;
        } else if (r.state == 4) {
            res.dp = l.dp + 1 + r.dp;
            res.state = 4;
        } else {
            res.dp = l.dp + r.dp + 1;
            res.state = 4;
        }
    } else {
        if (r.state == 0) {
            res.dp = l.dp + 1 + r.dp;
            res.state = 3;
        } else if (r.state == 1) {
            res.dp = l.dp + r.dp + 1;
            res.state = 5;
        } else if (r.state == 2) {
            res.dp = l.dp + 1 + r.dp;
            res.state = 3;
        } else if (r.state == 3) {
            res.dp = l.dp + r.dp + 1;
            res.state = 3;
        } else if (r.state == 4) {
            res.dp = l.dp + 1 + r.dp;
            res.state = 5;
        } else {
            res.dp = l.dp + r.dp + 1;
            res.state = 5;
        }
    }
    return res;
}

void upd(int i) {
    if (i == -1) {
        return;
    }
    push(i);
    if (t[i].ch[0] != -1) {
        push(t[i].ch[0]);
    }
    if (t[i].ch[1] != -1) {
        push(t[i].ch[1]);
    }
    Item& dp = t[i].dp;
    Item& dprev = t[i].dprev;
    dp.dp = t[i].sum;
    if (t[i].cnt > 0) {
        dp.state = 3;
    } else {
        dp.state = 0;
    }
    dprev = dp;
    if (t[i].ch[0] != -1) {
        dp = unite(t[t[i].ch[0]].dp, dp);
        dprev = unite(dprev, t[t[i].ch[0]].dprev);
    }
    if (t[i].ch[1] != -1) {
        dp = unite(dp, t[t[i].ch[1]].dp);
        dprev = unite(t[t[i].ch[1]].dprev, dprev);
    }

}

void rotate(int v) {
    if (v == -1 || is_root(v)) {
        return;
    }
    int u = t[v].p, p = is_root(u) ? -1 : t[u].p;
    push(p);
    push(u);
    push(v);
    int id = chnum(v);
    t[v].p = t[u].p;
    t[u].ch[id] = t[v].ch[1 - id];
    if (t[u].ch[id] != -1) {
        t[t[u].ch[id]].p = u;
    }
    t[v].ch[1 - id] = u;
    t[u].p = v;
    if (p != -1) {
        if (t[p].ch[0] == u) {
            t[p].ch[0] = v;
        } else {
            t[p].ch[1] = v;
        }
    }
    upd(u);
    upd(v);
}

void splay(int x) {
    vi st;
    int cur = x;
    while (!is_root(cur)) {
        st.pb(cur);
        cur = t[cur].p;
    }
    st.pb(cur);
    while (!st.empty()) {
        push(st.back());
        st.pop_back();
    }
    while (!is_root(x)) {
        int p = t[x].p;
        if (is_root(p)) {
            rotate(x);
            break;
        }
        int q = t[p].p;
        if (chnum(x) == chnum(p)) {
            rotate(p);
        } else {
            rotate(x);
        }
        rotate(x);
    }
}

void expose(int x) {
    splay(x);
    push(x);
    if (t[x].ch[1] != -1) {
        push(t[x].ch[1]);
        t[x].cnt += 1 - (t[t[x].ch[1]].dp.state & 1);
        t[x].sum += t[t[x].ch[1]].dp.dp + (t[t[x].ch[1]].dp.state & 1);
        t[x].ch[1] = -1;
        upd(x);
    }
    while (t[x].p != -1) {
        splay(t[x].p);
        push(t[x].p);
        push(x);
        t[t[x].p].cnt -= 1 - (t[x].dp.state & 1);
        t[t[x].p].sum -= t[x].dp.dp + (t[x].dp.state & 1);
        if (t[t[x].p].ch[1] != -1) {
            push(t[t[x].p].ch[1]);
            t[t[x].p].cnt += 1 - (t[t[t[x].p].ch[1]].dp.state & 1);
            t[t[x].p].sum += t[t[t[x].p].ch[1]].dp.dp + (t[t[t[x].p].ch[1]].dp.state & 1);
        }
        t[t[x].p].ch[1] = x;
        upd(t[x].p);
        splay(x);
    }
}

void make_root(int x) {
    expose(x);
    t[x].rev ^= 1;
    push(x);
}

void update(int x, int y) {
    make_root(x);
    make_root(y);
    if (is_root(x)) {
        t[x].p = y;
        push(x);
        t[y].cnt += 1 - (t[x].dp.state & 1);
        t[y].sum += t[x].dp.dp + (t[x].dp.state & 1);
    } else {
        expose(y);
        t[x].p = -1;
        push(x);
        t[y].cnt -= 1 - (t[x].dp.state & 1);
        t[y].sum -= t[x].dp.dp + (t[x].dp.state & 1);
    }
    upd(y);
}

int get(int x) {
    make_root(x);
    push(x);
    return t[x].dp.dp + (t[x].dp.state & 1);
}

void solve() {
    int g, n;
    cin >> g >> n;
    for (int i = 0; i < n; i++) {
        t[i].ch[0] = t[i].ch[1] = t[i].p = -1;
        t[i].rev = false;
        t[i].cnt = t[i].sum = 0;
        t[i].dp.dp = t[i].dp.state = t[i].dprev.dp = t[i].dprev.state = 0;
    }
    vi v(n), u(n);
    for (int i = 0; i + 1 < n; ++i) {
        cin >> v[i] >> u[i];
        --v[i], --u[i];
        update(v[i], u[i]);
    }
    int q;
    cin >> q;
    while (q--) {
        int t, a;
        cin >> t >> a;
        --a;
        if (t == 1) {
            update(v[a], u[a]);
        } else {
            cout << get(a) << "\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int test = 1;
    // cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}
